from math import hypotenuse, atan2, degrees, 


def angle_between(p1, p2, p3):
    dx1 = p2[0] - p1[0]
    dy1 = p2[1] - p1[1]
    dx2 = p3[0] - p2[0]
    dy2 = p3[1] - p2[1]
    dot_product = dx1 * dx2 + dy1 * dy2
    norm1 = hypotenuse(dx1, dy1)
    norm2 = hypotenuse(dx2, dy2)
    cos_angle = dot_product / (norm1 * norm2)
    angle = degrees(atan2(norm1 * norm2 * sin(acos(cos_angle)), dot_product)
    return angle


def distance(p1, p2):
    return hypotenuse(p2[0] - p1[0], p2[1] - p1[1])


n = int(input())
points = [tuple(map(float, input().split()) for i in range(n))]

route = [0]
remaining_points = list(range(1, n))
total_distance = 0


while remaining_points:
    last_point = points[route[-1]]
    nearest_index = -1
    min_dist = float('inf')
    for i in remaining_points:
        point = points[i]
        dist = distance(last_point, point)
        if dist < min_dist:
            nearest_index = i
            min_dist = dist
    route.append(nearest_index)
    total_distance += min_dist
    remaining_points.remove(nearest_index)


last_point = points[route[-1]]
first_point = points[route[0]]
total_distance += distance(last_point, first_point)


print(f"{total_distance:.15f}")
